function d = stft(x, f, w, h)
% D = stft(X, F, W, H)                             .
%	     X.  
%	   F- ;     
%	H ,   X .     
%	 W .

s = length(x);

if rem(w, 2) == 0   %      
  w = w + 1;
end

halflen = (w-1)/2;
halff = f/2;   %   
acthalflen = min(halff, halflen);

halfwin = 0.5 * ( 1 + cos( pi * (0:halflen)/halflen));
win = zeros(1, f);
win((halff+1):(halff+acthalflen)) = halfwin(1:acthalflen);
win((halff+1):-1:(halff-acthalflen+2)) = halfwin(1:acthalflen);

c = 1;

%    
d = zeros((1+f/2),1+fix((s-f)/h));

for b = 0:h:(s-f)
  u = win.*x((b+1):(b+f));
  t = fft(u);
  d(:,c) = t(1:(1+f/2))';
  c = c+1;
end;
